'----------------------------------------------------------------------------------------------------------------------
'
' SCRIPT D'INSTALLATION POUR FICHIERS TRACKMANIA
'
'----------------------------------------------------------------------------------------------------------------------
'
' Installe les fichiers spcifis dans le dossier correspondant de TrackMania. L'utilisation de  ce  script  n'est  pas
' obligatoire,  il est tout  fait possible d'installer les fichiers manuellement. C'est juste pour les feignants comme
' moi, qui prfrent lancer un script  farfouiller dans les dossiers.
'
'----------------------------------------------------------------------------------------------------------------------



'----------------------------------------------------------------------------------------------------------------------
' Liste des fichiers  installer
'----------------------------------------------------------------------------------------------------------------------

' Array ( Array ( Nom-fichier, Intitul-si-facultatif, Destination, Relancer-TM-si-pas-zero ), ... )
Fichiers = Array( Array( "Gougou-Gaming 01 (fixe).zip", "", "Skins\Any\Advertisement\Gougou", 1), _
                  Array( "Gougou-Gaming 01 (fixe).zip.loc", "le locator", "Skins\Any\Advertisement\Gougou", 1))



'----------------------------------------------------------------------------------------------------------------------
' Point d'entre
'----------------------------------------------------------------------------------------------------------------------

InstalleLesFichiers



'----------------------------------------------------------------------------------------------------------------------
' Procdure d'installation
'----------------------------------------------------------------------------------------------------------------------

Sub InstalleLesFichiers()
Dim FileSys, WShell
Dim DossierTrackMania, DossierDestination
Dim i, Copier, Relancer
  On Error Resume Next
  'Instanciation des composants COM: FileSystemObject et WshShell
  Set FileSys = CreateObject("Scripting.FileSystemObject")
  If Err.Number <> 0 Then
    MsgBox "1: Ce script ne peut pas fonctionner si les composants de scripting ne sont pas installs sur le PC.", vbCritical
    Exit Sub
  End If
  Set WShell = CreateObject("WScript.Shell")
  If Err.Number <> 0 Then
    MsgBox "2: Ce script ne peut pas fonctionner si WScript n'est pas install sur le PC.", vbCritical
    Exit Sub
  End If
  'Rcupration du chemin vers le dossier de profil personnel
  DossierTrackMania = WShell.ExpandEnvironmentStrings("%USERPROFILE%")
  If Err.Number <> 0 Then
    MsgBox "3: Impossible de retrouver le dossier utilisateur.", vbCritical
    Exit Sub
  End If
  If Right(DossierTrackMania, 1) <> "\" Then DossierTrackMania = DossierTrackMania & "\"
  'Recherche du dossier des documents
  If FileSys.FolderExists(DossierTrackMania & "Documents") Then
    DossierTrackMania = DossierTrackMania & "Documents\"
  ElseIf FileSys.FolderExists(DossierTrackMania & "Mes documents") Then
    DossierTrackMania = DossierTrackMania & "Mes documents\"
  ElseIf FileSys.FolderExists(DossierTrackMania & "My documents") Then
    DossierTrackMania = DossierTrackMania & "My documents\"
  Else
    MsgBox "4: Impossible de retrouver le dossier des documents.", vbCritical
    Exit Sub
  End If
  'Recherche du dossier TrackMania. D'abord TMUF puis TMNF
  If FileSys.FolderExists(DossierTrackMania & "TrackMania") Then
    DossierTrackMania = DossierTrackMania & "TrackMania\"
  ElseIf FileSys.FolderExists(DossierTrackMania & "TmForever") Then
    DossierTrackMania = DossierTrackMania & "TmForever\"
  Else
    MsgBox "5: Impossible de retrouver le dossier local de TrackMania", vbCritical
    Exit Sub
  End If
  Relancer = False
  'Copie des fichiers
  For i=0 To UBound(Fichiers)
    Err.Clear
    If Len(Fichiers(i)(1)) = 0 Then
      'Pas d'intitul => Fichier  installer sans confirmation
      Copier = True
    Else
      'Intitul => Poser la question "voulez-vous installer [INTITULE] ?"
      Copier = (MsgBox("Voulez-vous installer " & Fichiers(i)(1) & " ?", vbYesNo + vbDefaultButton1 + vbQuestion) = vbYes)
    End If
    If Copier Then
      DossierDestination = Fichiers(i)(2)
      If Right(DossierDestination, 1) <> "\" Then DossierDestination = DossierDestination + "\"
      If Left(DossierDestination, 1) = "\" Then DossierDestination = Mid(DossierDestination, 2)
      If Not CreerDossiers(FileSys, DossierTrackMania & DossierDestination) Then
        MsgBox "6: Impossible de crer le dossier de destination """ & DossierTrackMania & DossierDestination & """ !" & vbCrLf & "(" & Err.Number & ") " & Err.Description, vbCritical
        Exit Sub
      End If
      FileSys.CopyFile Fichiers(i)(0), DossierTrackMania & DossierDestination & Fichiers(i)(0)
      If Err.Number <> 0 Then
        MsgBox "7: Impossible de copier le fichier """ & Fichiers(i)(1) & """" & vbCrLf & "(" & Err.Number & ") " & Err.Description, vbCritical
        Exit Sub
      End If
      If Fichier(i)(3) <> 0 Then Relancer = True
    End If
  Next 'i
  If Relancer Then
    MsgBox "Les fichiers ont t copis." & vbCrLf & vbCrLf & "Ils seront utilisables au prochain lancement de TrackMania.", vbInformation
  Else
    MsgBox "Les fichiers ont t copis." & vbCrLf & vbCrLf & "Ils sont immdiatement utilisables. Vous devrez ventuellement rafrachir l'affichage du dossier si TrackMania est dj lanc.", vbInformation
  End If
  Set WShell = Nothing
  Set FileSys = Nothing
  Err.Clear
End Sub



'----------------------------------------------------------------------------------------------------------------------
' Cration de dossiers
'----------------------------------------------------------------------------------------------------------------------

Function CreerDossiers(FSO, Arborescence)
Dim Volume, Chemin, Termes, p, Continuer, i
  On Error Resume Next
  Chemin = Arborescence
  Continuer = False
  If Left(Chemin, 2) = "\\" Then
    'Chemin UNC
    p = InStr(3, Chemin, "\")
    If p > 0 Then
      p = InStr(p + 1, Chemin, "\")
      If p > 0 Then
        Volume = Left(Chemin, p - 1)
        Chemin = Mid(Chemin, p + 1)
        Continuer = FSO.FolderExists(Volume)
      End If
    End If
  ElseIf Mid(Chemin, 2, 1) = ":" Then
    Disque local
    Volume = Left(Chemin, 2)
    Chemin = Mid(Chemin, 4)
    Continuer = FSO.DriveExists(Volume)
  End If
  If Continuer Then
    Termes = Split(Chemin, "\")
    Chemin = Volume
    For i = 0 To UBound(Termes)
      Err.Clear
      Chemin = Chemin & "\" & Termes(i)
      If Not FSO.FolderExists(Chemin) Then
        FSO.CreateFolder Chemin
        If Err.Number <> 0 Then
          Err.Clear
          CreerDossiers = False
          Exit Function
        End If
      End If
    Next 'i
    CreerDossiers = True
  Else
    CreerDossiers = False
  End If
End Function



'EOF